source stooop.tcl
namespace import stooop::*

### check user defined cloning operation error checking

# expected output:
## class ::a copy constructor must have 2 arguments exactly
## class ::A copy constructor must have 2 arguments exactly
## class ::b::c copy constructor must have 2 arguments exactly
## class ::B::C copy constructor must have 2 arguments exactly

catch {
    class a {}
    proc a::a {this} {
        set ($this,x) 0
    }
    proc a::a {this copy dummy} {}
    new [new a]
} message
puts $message

catch {
    class A {
        proc A {this} {
            set ($this,x) 0
        }
        proc A {this copy dummy} {}
    }
    new [new A]
} message
puts $message

catch {
    class b {}
    class b::c {}
    proc b::c::c {this} {
        set ($this,x) 0
    }
    proc b::c::c {this copy dummy} {}
    new [new b::c]
} message
puts $message

catch {
    class B {
        class C {
            proc C {this} {
                set ($this,x) 0
            }
            proc C {this copy dummy} {}
        }
        new [new C]
    }
} message
puts $message
